*------------------------------------------------------------------
*  swp2ga_disp_all.gs
*  GrADS sample script to display gart... file made by swp2ga
*  to display DZ, VE, time, AZ, EL, and Dis [km]
*     x=1: time (day_sec),  x=2: AZ,  x=3:EL
*     y=1: distance [m] from the radar to the cell
*
*  usage from shell: >grads -lc "run swp2ga_disp_all gart.xxx.ctl"'  
*
*                                     Feb. 26, 1999  by Shin Satoh
*------------------------------------------------------------------
function main(args)
  if (args='')
    say 'Enter ctl file:'
    pull args
  endif

  'open 'args
  ' q dims'
  xsize = subwrd(result,18)
  ysize = subwrd(result,31)

  'set vpage off'
  'set mproj off'
  'set gxout grfill'
  'set grads off'

*=== Disp DZ & VE ===
  'set x 4 'xsize
  'set y 2 'ysize
  'set xyrev on'

  'set parea 0.7 4.7 3.0 8.0'
  'set clevs 5 10 15 20 25 30 35 40 45 50 55 60'
  'd DZ'
  'run cbarn 0.5 0 2.6 2.3'

  'set parea 5.1 9.1 3.0 8.0'
  'set clevs -20 -16 -12 -8 -4 0 4 8 12 16 20'
  'd VE'
  'run cbarn 0.5 0 7.2 2.3'

  'set strsiz 0.18'
  'set string 1 bc 5 0'
  'draw string 4.7 2.5 ESTIMATED ANTENNA ANGLE (RAY NUMBER)'
  'draw string 2.7 8.2 Reflectivity factor [dBZ]'
  'draw string 7.1 8.2 Doppler velocity [m/s]'
  'set string 1 tc 5 90'
  'draw string 0.2 5.5 ESTIMATED RANGE (CELL NUMBER)'

*=== Disp time(day_sec), AZ, EL
  'set vpage off'
  'set grads off'
  'set grid off'
  'set gxout line'

  'set parea 2.0 10.0 0.7 1.9'
  'set x 3'
  'set y 2 'ysize
  'set cmark 0'
  'set ccolor 11'
  'd DZ'

  'set x 2'
  'set y 2 'ysize
  'set cmark 0'
  'set ccolor 2'
  'd DZ'

  'set x 1'
  'set y 2 'ysize
  'set cmark 0'
  'set ccolor 1'
  'd DZ'

  'set string 1 tl 5 0'
  'draw string 0.4 0.4 SEC'
  'set string 2 tl 5 0'
  'draw string 1.1 0.4 AZ'
  'set string 11 tl 5 0'
  'draw string 1.6 0.4 EL'
  'set string 1 tl 5 0'
  'draw string 3.2 0.4 ESTIMATED ANTENNA ANGLE (RAY NUMBER)'

*=== Disp distance [km] from the radar to the cell
  'set vpage off'
  'set grads off'
  'set xyrev on'
  'set xlint 20'

  'set parea 9.5 10.5 3.0 8.0'
  'set x 4 'xsize
  'set y 1'
  'set cmark 0'
  'set ccolor 1'
  'define diskm=DZ*0.001'
  'd diskm'

  'set strsiz 0.16'
  'set string 1 bc 5 0'
  'draw string 10.0 8.2 Range [km]'
return

