/* 	$Id: dd_crackers.c,v 1.9 1997/09/05 15:02:38 oye Exp $	 */

/* definitions and tables in this file come from
 * /scr/amber/oye/solso/translate/glom_struct.txt which was produced by
 * /home/steam/oye/scripts/crackers.perl
 */

# ifndef CRAK_LST_INC
# define CRAK_LST_INC
# define    type_long  3
# define  type_double  5
# define    type_char  1
# define   type_float  4
# define   type_short  2
# define     type_int  6

# define   offs_ndx 0
# define     id_ndx 1
# define   size_ndx 2
# define    dim_ndx 3
# define    rpt_ndx 4
# define    skp_ndx 5
# define  sparc_ndx 6
# define  ndx_count 7
# endif

extern int LittleEndian;

void crackers();
void piraq_crackers();
void swack_short();
void swack_long();
void swack_double();

/* c------------------------------------------------------------------------ */

void ddin_crack_rktb (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=28;
   int item_count=7;

   static int crk_rot_ang_table [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    4,    4,    1,    1,    1,    8},
      {   12,    3,    4,    1,    4,    4,   12},
      {   16,    3,    4,    1,    1,    1,   16},
      {   20,    3,    4,    1,    1,    1,   20},
      {   24,    3,    4,    1,    1,    1,   24},
   };

   crackers(srs, dst, item_count, ndx_count, crk_rot_ang_table
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_sswbLE (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=196;
   int item_count=17;

   static int crk_super_SWIB [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    8,    8,    4},
      {    8,    3,    4,    1,    1,    1,    8},
      {   12,    3,    4,    1,    1,    1,   12},
      {   16,    3,    4,    1,    1,    1,   16},
      {   20,    3,    4,    1,    1,    1,   20},
      {   24,    3,    4,    1,    1,    1,   24},
      {   28,    3,    4,    1,    1,    1,   28},
      {   32,    3,    4,    1,    1,    1,   32},
      {   36,    1,    1,    8,    8,    1,   36},
      {   44,    5,    8,    1,    2,    2,   48},
      {   52,    5,    8,    1,    1,    1,   56},
      {   60,    3,    4,    1,   34,    5,   64},
      {   64,    3,    4,    1,    1,    1,   68},
      {   68,    3,    4,    1,    1,    1,   72},
      {   72,    3,    4,    7,    7,    1,   76},
      {  100,    3,    4,   24,   24,    1,  104},
   };

   crackers(srs, dst, item_count, ndx_count, crk_super_SWIB
	    , sparc_ndx, offs_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_sswb (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=196;
   int item_count=17;

   static int crk_super_SWIB [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    8,    8,    4},
      {    8,    3,    4,    1,    1,    1,    8},
      {   12,    3,    4,    1,    1,    1,   12},
      {   16,    3,    4,    1,    1,    1,   16},
      {   20,    3,    4,    1,    1,    1,   20},
      {   24,    3,    4,    1,    1,    1,   24},
      {   28,    3,    4,    1,    1,    1,   28},
      {   32,    3,    4,    1,    1,    1,   32},
      {   36,    1,    1,    8,    8,    1,   36},
      {   44,    5,    8,    1,    2,    2,   48},
      {   52,    5,    8,    1,    1,    1,   56},
      {   60,    3,    4,    1,   34,    5,   64},
      {   64,    3,    4,    1,    1,    1,   68},
      {   68,    3,    4,    1,    1,    1,   72},
      {   72,    3,    4,    7,    7,    1,   76},
      {  100,    3,    4,   24,   24,    1,  104},
   };

   crackers(srs, dst, item_count, ndx_count, crk_super_SWIB
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_vold (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=72;
   int item_count=18;

   static int crk_volume_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    2,    2,    1,    2,    2,    8},
      {   10,    2,    2,    1,    1,    1,   10},
      {   12,    3,    4,    1,    1,    1,   12},
      {   16,    1,    1,   20,   20,    1,   16},
      {   36,    2,    2,    1,    6,    6,   36},
      {   38,    2,    2,    1,    1,    1,   38},
      {   40,    2,    2,    1,    1,    1,   40},
      {   42,    2,    2,    1,    1,    1,   42},
      {   44,    2,    2,    1,    1,    1,   44},
      {   46,    2,    2,    1,    1,    1,   46},
      {   48,    1,    1,    8,    8,    1,   48},
      {   56,    1,    1,    8,    8,    1,   56},
      {   64,    2,    2,    1,    4,    4,   64},
      {   66,    2,    2,    1,    1,    1,   66},
      {   68,    2,    2,    1,    1,    1,   68},
      {   70,    2,    2,    1,    1,    1,   70},
   };

   crackers(srs, dst, item_count, ndx_count, crk_volume_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_cfac (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=72;
   int item_count=18;

   static int crk_correction_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    4,    4,    1,   16,   16,    8},
      {   12,    4,    4,    1,    1,    1,   12},
      {   16,    4,    4,    1,    1,    1,   16},
      {   20,    4,    4,    1,    1,    1,   20},
      {   24,    4,    4,    1,    1,    1,   24},
      {   28,    4,    4,    1,    1,    1,   28},
      {   32,    4,    4,    1,    1,    1,   32},
      {   36,    4,    4,    1,    1,    1,   36},
      {   40,    4,    4,    1,    1,    1,   40},
      {   44,    4,    4,    1,    1,    1,   44},
      {   48,    4,    4,    1,    1,    1,   48},
      {   52,    4,    4,    1,    1,    1,   52},
      {   56,    4,    4,    1,    1,    1,   56},
      {   60,    4,    4,    1,    1,    1,   60},
      {   64,    4,    4,    1,    1,    1,   64},
      {   68,    4,    4,    1,    1,    1,   68},
   };

   crackers(srs, dst, item_count, ndx_count, crk_correction_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_celv (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=16;
   int item_count=4;

   static int crk_cell_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    2,    2,    4},
      {    8,    3,    4,    1,    1,    1,    8},
      {   12,    4,    4,    1,    1,    1,   12},
   };

   crackers(srs, dst, item_count, ndx_count, crk_cell_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_radd (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=300;
   int item_count=53;

   static int crk_radar_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    1,    1,    8,    8,    1,    8},
      {   16,    4,    4,    1,    8,    8,   16},
      {   20,    4,    4,    1,    1,    1,   20},
      {   24,    4,    4,    1,    1,    1,   24},
      {   28,    4,    4,    1,    1,    1,   28},
      {   32,    4,    4,    1,    1,    1,   32},
      {   36,    4,    4,    1,    1,    1,   36},
      {   40,    4,    4,    1,    1,    1,   40},
      {   44,    4,    4,    1,    1,    1,   44},
      {   48,    2,    2,    1,    2,    2,   48},
      {   50,    2,    2,    1,    1,    1,   50},
      {   52,    4,    4,    1,    3,    3,   52},
      {   56,    4,    4,    1,    1,    1,   56},
      {   60,    4,    4,    1,    1,    1,   60},
      {   64,    2,    2,    1,    4,    4,   64},
      {   66,    2,    2,    1,    1,    1,   66},
      {   68,    2,    2,    1,    1,    1,   68},
      {   70,    2,    2,    1,    1,    1,   70},
      {   72,    4,    4,    1,    7,    7,   72},
      {   76,    4,    4,    1,    1,    1,   76},
      {   80,    4,    4,    1,    1,    1,   80},
      {   84,    4,    4,    1,    1,    1,   84},
      {   88,    4,    4,    1,    1,    1,   88},
      {   92,    4,    4,    1,    1,    1,   92},
      {   96,    4,    4,    1,    1,    1,   96},
      {  100,    2,    2,    1,    2,    2,  100},
      {  102,    2,    2,    1,    1,    1,  102},
      {  104,    4,    4,    1,   10,   10,  104},
      {  108,    4,    4,    1,    1,    1,  108},
      {  112,    4,    4,    1,    1,    1,  112},
      {  116,    4,    4,    1,    1,    1,  116},
      {  120,    4,    4,    1,    1,    1,  120},
      {  124,    4,    4,    1,    1,    1,  124},
      {  128,    4,    4,    1,    1,    1,  128},
      {  132,    4,    4,    1,    1,    1,  132},
      {  136,    4,    4,    1,    1,    1,  136},
      {  140,    4,    4,    1,    1,    1,  140},
      {  144,    3,    4,    1,    1,    1,  144},
      {  148,    1,    1,    8,    8,    1,  148},
      {  156,    3,    4,    1,    1,    1,  156},
      {  160,    4,    4,    1,   29,    9,  160},
      {  164,    4,    4,    1,    1,    1,  164},
      {  168,    4,    4,    1,    1,    1,  168},
      {  172,    4,    4,   11,   11,    1,  172},
      {  216,    4,    4,   11,   11,    1,  216},
      {  260,    4,    4,    1,    1,    1,  260},
      {  264,    4,    4,    1,    1,    1,  264},
      {  268,    4,    4,    1,    1,    1,  268},
      {  272,    4,    4,    1,    1,    1,  272},
      {  276,    3,    4,    1,    1,    1,  276},
      {  280,    1,    1,   20,   20,    1,  280},
   };

   crackers(srs, dst, item_count, ndx_count, crk_radar_d 
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_parm (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=216;
   int item_count=30;

   static int crk_parameter_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    1,    1,    8,    8,    1,    8},
      {   16,    1,    1,   40,   40,    1,   16},
      {   56,    1,    1,    8,    8,    1,   56},
      {   64,    2,    2,    1,    2,    2,   64},
      {   66,    2,    2,    1,    1,    1,   66},
      {   68,    4,    4,    1,    1,    1,   68},
      {   72,    2,    2,    1,    4,    4,   72},
      {   74,    2,    2,    1,    1,    1,   74},
      {   76,    2,    2,    1,    1,    1,   76},
      {   78,    2,    2,    1,    1,    1,   78},
      {   80,    1,    1,    8,    8,    1,   80},
      {   88,    4,    4,    1,    3,    3,   88},
      {   92,    4,    4,    1,    1,    1,   92},
      {   96,    4,    4,    1,    1,    1,   96},
      {  100,    3,    4,    1,    2,    2,  100},
      {  104,    3,    4,    1,    1,    1,  104},
      {  108,    1,    1,    8,    8,    1,  108},
      {  116,    3,    4,    1,    2,    2,  116},
      {  120,    3,    4,    1,    1,    1,  120},
      {  124,    4,    4,    1,    1,    1,  124},
      {  128,    3,    4,    1,    1,    1,  128},
      {  132,    1,    1,   32,   32,    1,  132},
      {  164,    3,    4,    1,    1,    1,  164},
      {  168,    1,    1,   32,   32,    1,  168},
      {  200,    3,    4,    1,    1,    1,  200},
      {  204,    4,    4,    1,    3,    3,  204},
      {  208,    4,    4,    1,    1,    1,  208},
      {  212,    4,    4,    1,    1,    1,  212},
   };

   crackers(srs, dst, item_count, ndx_count, crk_parameter_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_swib (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=40;
   int item_count=9;

   static int crk_sweepinfo_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    1,    1,    8,    8,    1,    8},
      {   16,    3,    4,    1,    2,    2,   16},
      {   20,    3,    4,    1,    1,    1,   20},
      {   24,    4,    4,    1,    3,    3,   24},
      {   28,    4,    4,    1,    1,    1,   28},
      {   32,    4,    4,    1,    1,    1,   32},
      {   36,    3,    4,    1,    1,    1,   36},
   };

   crackers(srs, dst, item_count, ndx_count, crk_sweepinfo_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_asib (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=80;
   int item_count=20;

   static int crk_platform_i [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    4,    4,    1,   18,   18,    8},
      {   12,    4,    4,    1,    1,    1,   12},
      {   16,    4,    4,    1,    1,    1,   16},
      {   20,    4,    4,    1,    1,    1,   20},
      {   24,    4,    4,    1,    1,    1,   24},
      {   28,    4,    4,    1,    1,    1,   28},
      {   32,    4,    4,    1,    1,    1,   32},
      {   36,    4,    4,    1,    1,    1,   36},
      {   40,    4,    4,    1,    1,    1,   40},
      {   44,    4,    4,    1,    1,    1,   44},
      {   48,    4,    4,    1,    1,    1,   48},
      {   52,    4,    4,    1,    1,    1,   52},
      {   56,    4,    4,    1,    1,    1,   56},
      {   60,    4,    4,    1,    1,    1,   60},
      {   64,    4,    4,    1,    1,    1,   64},
      {   68,    4,    4,    1,    1,    1,   68},
      {   72,    4,    4,    1,    1,    1,   72},
      {   76,    4,    4,    1,    1,    1,   76},
   };

   crackers(srs, dst, item_count, ndx_count, crk_platform_i
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_ryib (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=44;
   int item_count=13;

   static int crk_ray_i [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    3,    3,    4},
      {    8,    3,    4,    1,    1,    1,    8},
      {   12,    3,    4,    1,    1,    1,   12},
      {   16,    2,    2,    1,    4,    4,   16},
      {   18,    2,    2,    1,    1,    1,   18},
      {   20,    2,    2,    1,    1,    1,   20},
      {   22,    2,    2,    1,    1,    1,   22},
      {   24,    4,    4,    1,    4,    4,   24},
      {   28,    4,    4,    1,    1,    1,   28},
      {   32,    4,    4,    1,    1,    1,   32},
      {   36,    4,    4,    1,    1,    1,   36},
      {   40,    3,    4,    1,    1,    1,   40},
   };

   crackers(srs, dst, item_count, ndx_count, crk_ray_i
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void ddin_crack_qdat (srs, dst, limit)
  char *srs, *dst;
  int limit;
{
   int sizeof_struct=56;
   int item_count=8;

   static int crk_qparamdata_d [][7] = {
      {    0,    1,    1,    4,    4,    1,    0},
      {    4,    3,    4,    1,    1,    1,    4},
      {    8,    1,    1,    8,    8,    1,    8},
      {   16,    3,    4,    1,    2,    2,   16},
      {   20,    3,    4,    1,    1,    1,   20},
      {   24,    2,    2,    4,    8,    2,   24},
      {   32,    2,    2,    4,    4,    1,   32},
      {   40,    4,    4,    4,    4,    1,   40},
   };

   crackers(srs, dst, item_count, ndx_count, crk_qparamdata_d
	    , offs_ndx, sparc_ndx, limit);
}
/* c------------------------------------------------------------------------ */

void crackers(srs, dst, item_count, ndx_cnt, tbl, srs_ndx, dst_ndx, limit)
  char *srs, *dst;
  const int item_count, ndx_cnt;
  int *tbl;
  int srs_ndx, dst_ndx, limit;
{
   int ii, jj, itm, nn, *row = tbl;
   char *ss=srs, *tt=dst;
   char *deep6 = 0;


   for(itm=0; itm < item_count;) {

      switch(*(row + id_ndx)) {

       case type_char:		/* just copy it */
	 memcpy(tt, ss, *(row + rpt_ndx));
	 break;

       case type_short:

	 if(*(row + rpt_ndx) > 1) {
	    swack_short(ss, tt, *(row + rpt_ndx));
	 }
	 else {			/* just swap one item */
	    *tt++ = *(ss+1);
	    *tt++ = *ss;
	 }
	 break;

       case type_long:
       case type_float:
       case type_int:

	 if(*(row + rpt_ndx) > 1) {
	    swack_long(ss, tt, *(row + rpt_ndx));
	 }
	 else {			/* just swap one item */
	    *tt++ = *(ss+3);
	    *tt++ = *(ss+2);
	    *tt++ = *(ss+1);
	    *tt++ = *ss;
	 }
	 break;

       case type_double:
	 swack_double(ss, tt, *(row + rpt_ndx));
	 break;

       default:
	 *deep6 = 0;
	 break;

      }
      itm += *(row + skp_ndx);
      row = tbl + itm * ndx_cnt;
      ss = srs + (*(row + srs_ndx));
      tt = dst + (*(row + dst_ndx));
   }
}
/* c------------------------------------------------------------------------ */

void piraq_crackers
(srs, dst, item_count, ndx_cnt, tbl, srs_ndx, dst_ndx, limit)
  char *srs, *dst;
  int item_count, ndx_cnt, *tbl;
  int srs_ndx, dst_ndx, limit;
{
   int ii, jj, itm, nn, *row = tbl;
   char *ss=srs, *tt=dst;

   for(itm=0; itm < item_count;) {

      switch(*(row + id_ndx)) {

       case type_char:		/* just copy it */
	 memcpy(tt, ss, *(row + rpt_ndx));
	 break;

       case type_short:

	 memcpy(tt, ss, *(row + rpt_ndx) * sizeof(short));
	 break;

       case type_long:
       case type_float:
       case type_int:

	 memcpy(tt, ss, *(row + rpt_ndx) * sizeof(long));
	 break;

       case type_double:	/* same as unpacking two floats? */

	 memcpy(tt, ss, *(row + rpt_ndx) * sizeof(double));
	 break;

       default:
	 break;

      }
      itm += *(row + skp_ndx);
      row = tbl + itm * ndx_cnt;
      ss = srs + (*(row + srs_ndx));
      tt = dst + (*(row + dst_ndx));
   }
}

/* c------------------------------------------------------------------------ */

void crackers_orig(srs, dst, item_count, ndx_cnt, tbl, srs_ndx, dst_ndx, limit)
  char *srs, *dst;
  int item_count, ndx_cnt, tbl[item_count][ndx_cnt];
  int srs_ndx, dst_ndx, limit;
{
   int ii, jj, itm, nn;
   char *ss=srs, *tt=dst;

   for(itm=0; itm < item_count;) {

# ifdef obsolete
      for(jj=0; jj < ndx_cnt; jj++) {
	 printf(" %d", tbl[itm][jj]);
      }
      printf("\n");
# endif
      switch(tbl[itm][id_ndx]) {

       case type_char:		/* just copy it */
	 memcpy(tt, ss, tbl[itm][rpt_ndx]);
	 itm += tbl[itm][skp_ndx];
	 ss = srs + tbl[itm][srs_ndx];
	 tt = dst + tbl[itm][dst_ndx];
	 break;

       case type_short:

	 if(tbl[itm][rpt_ndx] > 1) {
	    swack_short(ss, tt, tbl[itm][rpt_ndx]);
	    itm += tbl[itm][skp_ndx];
	    ss = srs + tbl[itm][srs_ndx];
	    tt = dst + tbl[itm][dst_ndx];
	 }
	 else {			/* just swap one item */
	    itm += tbl[itm][skp_ndx];
	    *tt++ = *(ss+1);
	    *tt++ = *ss;
	    ss = srs + tbl[itm][srs_ndx];
	    tt = dst + tbl[itm][dst_ndx];
	 }
	 break;

       case type_long:
       case type_float:
       case type_int:

	 if(tbl[itm][rpt_ndx] > 1) {
	    swack_long(ss, tt, tbl[itm][rpt_ndx]);
	    itm += tbl[itm][skp_ndx];
	    ss = srs + tbl[itm][srs_ndx];
	    tt = dst + tbl[itm][dst_ndx];
	 }
	 else {			/* just swap one item */
	    itm += tbl[itm][skp_ndx];
	    *tt++ = *(ss+3);
	    *tt++ = *(ss+2);
	    *tt++ = *(ss+1);
	    *tt++ = *ss;
	    ss = srs + tbl[itm][srs_ndx];
	    tt = dst + tbl[itm][dst_ndx];
	 }
	 break;

       case type_double:

	 swack_double(ss, tt, tbl[itm][rpt_ndx]);
	 itm += tbl[itm][skp_ndx];
	 ss = srs + tbl[itm][srs_ndx];
	 tt = dst + tbl[itm][dst_ndx];
	 break;

       default:
	 break;

      }
   }
}
/* c------------------------------------------------------------------------ */

void swack_short(ss, tt, nn)
  char *ss, *tt;
  int nn;
{
   for(; nn--;) {
      *tt++ = *(ss+1);
      *tt++ = *ss;
      ss += 2;
   }
}
/* c------------------------------------------------------------------------ */

void swack2(ss, tt)
  char *ss, *tt;
{
   *tt++ = *(ss+1);
   *tt = *ss;
}
/* c------------------------------------------------------------------------ */

void swack_long(ss, tt, nn)
  char *ss, *tt;
  int nn;
{
   for(; nn--;) {
      *tt++ = *(ss+3);
      *tt++ = *(ss+2);
      *tt++ = *(ss+1);
      *tt++ = *ss;
      ss += 4;
   }
}
/* c------------------------------------------------------------------------ */

void swack4(ss, tt)
  char *ss, *tt;
{
   *tt++ = *(ss+3);
   *tt++ = *(ss+2);
   *tt++ = *(ss+1);
   *tt = *ss;
}
/* c------------------------------------------------------------------------ */

void swack_double(ss, tt, nn)
  char *ss, *tt;
  int nn;
{
   for(; nn--;) {
      *tt++ = *(ss+7);
      *tt++ = *(ss+6);
      *tt++ = *(ss+5);
      *tt++ = *(ss+4);
      *tt++ = *(ss+3);
      *tt++ = *(ss+2);
      *tt++ = *(ss+1);
      *tt++ = *ss;
      ss += 8;
   }
}
/* c------------------------------------------------------------------------ */
